// Copyright 2006-2010, by the California Institute of Technology.
// ALL RIGHTS RESERVED. United States Government Sponsorship acknowledged.
// Any commercial use must be negotiated with the Office of Technology Transfer
// at the California Institute of Technology.
//
// This software is subject to U. S. export control laws and regulations
// (22 C.F.R. 120-130 and 15 C.F.R. 730-774). To the extent that the software
// is subject to U.S. export control laws and regulations, the recipient has
// the responsibility to obtain export licenses or other export authority as
// may be required before exporting such information to foreign countries or
// providing access to foreign nationals.
//
// $Id: TextString.java 12806 2014-03-06 23:09:09Z mcayanan $
//

package gov.nasa.pds.tools.label;

import gov.nasa.arc.pds.tools.util.StrUtils;
import gov.nasa.pds.tools.constants.Constants.DictionaryType;

/**
 * @author pramirez
 * @author jagander
 * @version $Revision: 12806 $
 * 
 */
public class TextString extends Scalar {

  /**
   * 
   * @param value
   */
  public TextString(String value) {
    this(value, null);
  }

  /**
   * @param value
   * @param type
   */
  public TextString(String value, ValueType type) {
    super(value.replaceAll("\"", ""), type); //$NON-NLS-1$ //$NON-NLS-2$
  }

  @Override
  public boolean isSupportedPDSType(DictionaryType type) {
    if (DictionaryType.ALPHABET.equals(type)
        || DictionaryType.ALPHANUMERIC.equals(type)
        || DictionaryType.CHARACTER.equals(type)
        || DictionaryType.BIBLIO.equals(type)
        || DictionaryType.DATA_SET.equals(type)
        || DictionaryType.IDENTIFIER.equals(type)
        || DictionaryType.CONTEXT_DEPENDENT.equals(type)
        || DictionaryType.CONTEXTDEPENDENT.equals(type)) {
      return true;
    }
    return false;
  }

  public String normalize() {
    return StrUtils.normalize(this.toString());
  }
}
